let game=document.getElementById('gameCanvas');let frame=game.getContext('2d');frame.imageSmoothingEnabled=false;let frameId;const drawQueue=[];const __src='./';const __aud='./audio';const __img='./img';const __js='./js';function waniGameStart(){game=document.getElementById('gameCanvas');frame=game.getContext('2d');main();}
const random={range:(min,max)=>{return Math.random()*(max-min)+min;},color:()=>{const letters='0123456789ABCDEF';let color='#';for(var i=0;i<6;i++){color+=letters[Math.floor(Math.random()*16)];}
return color;}}
function drawText({text='hello world!',x=0,y=0,color="black",border="",align="left",size=24,width=5,font="FF",opacity=1}){frame.font=`${size}px ${font}`;frame.fillStyle=color;frame.textAlign=align;frame.lineWidth=width;frame.globalAlpha=opacity;if(border!==''){frame.strokeStyle=border;frame.strokeText(text,x,y);}
frame.fillText(text,x,y);frame.globalAlpha=1.0;}
const friendlyFireUrl=`./img/Friendly_Fire.ttf`;const friendlyFire=new FontFace('FF',`url(${friendlyFireUrl})`);friendlyFire.load().then((font)=>{document.fonts.add(font)});let displayRestart=true;let defaultTimeLeft=10;let defaultScore=0;let timeLeft=defaultTimeLeft;let score=defaultScore;let gameOver=false;let intervalId='';let rightHook=true;var colorStops=['#a66ee1','#e8f4f3','#a66ee1'];var animationSpeed=0.1;var frequency=0.02;function gradient(){const gradient=frame.createLinearGradient(0,0,0,game.height);for(var i=0;i<colorStops.length;i++){let stop=Math.max(0,Math.min(1,i/(colorStops.length-1)));gradient.addColorStop(stop,colorStops[i]);}
let centralColorStop=colorStops.length/2;let centralStop=Math.floor(centralColorStop)/(colorStops.length-1);gradient.addColorStop(centralStop-0.1,colorStops[Math.floor(centralColorStop)]);gradient.addColorStop(centralStop,colorStops[Math.floor(centralColorStop)]);gradient.addColorStop(centralStop+0.1,colorStops[Math.floor(centralColorStop)]);frame.fillStyle=gradient;frame.fillRect(0,0,game.width,game.height);}
function drawCenterPoint(){const centerX=game.width/2;const centerY=game.height/2;frame.beginPath();frame.moveTo(centerX,0);frame.lineTo(centerX,game.height);frame.stroke();frame.beginPath();frame.moveTo(0,centerY);frame.lineTo(game.width,centerY);frame.stroke();}
function updateTimeGraphic(){drawText({text:"Time: "+timeLeft,x:10,y:30});}
function updateScoreGraphic(){drawText({text:"Score: "+score,x:10,y:60});}
let blood=[];class BloodParticle{constructor(dir){this.x=game.width/2;this.y=game.height/2;this.size=random.range(2,10);this.speed=(11-this.size)*3;this.vx=dir*this.speed;this.vy=-1*random.range(3,10);this.opacity=Math.random()+0.2;this.gravity=0.3;}
draw(){frame.fillStyle=`rgba(255,0,0,${this.opacity})`;frame.beginPath();frame.arc(this.x,this.y,this.size/2,0,Math.PI*2);frame.fill();}
update(){this.vy+=this.gravity;this.x+=this.vx;this.y+=this.vy;this.opacity-=0.01;}}
function shootBlood(direction){for(let i=0;i<10;i++){blood.push(new BloodParticle(direction));}}
function updateBlood(){blood=blood.filter((particle)=>{return particle.opacity>0;});for(let i=0;i<blood.length;i++){blood[i].draw();blood[i].update();}}
class titleText{constructor(text,min,max,yOffset=0,speed=0.1){this.title=text;this.x=game.width/2;this.y=game.height/2+yOffset;this.size=min;this.min=min;this.max=max;this.speed=speed;this.growing=false;}
draw(){drawText({text:this.title,x:this.x,y:this.y,size:this.size,align:"center",color:"white",border:"black"})
this.size=(this.growing)?this.size+this.speed:this.size-this.speed;if(this.size<=this.min)this.growing=true;if(this.size>=this.max)this.growing=false;}}
class flashingText{constructor(text,yOffset=0,speed=0.03){this.title=text;this.x=game.width/2;this.y=game.height/2+yOffset;this.size=50;this.speed=speed;this.showing=true;this.opacity=0;}
draw(){drawText({text:this.title,x:this.x,y:this.y,size:this.size,align:"center",color:"white",border:"black",opacity:this.opacity})
this.opacity=(this.showing)?this.opacity+this.speed:this.opacity-this.speed;if(this.opacity<=0.01)this.showing=true;if(this.opacity>=1)this.showing=false;}}
class currentScore{constructor(){this.score=score;this.size=100;this.shrink=0.5}
draw(){if(score!==this.score){this.size=120;this.score=score;}
drawText({text:this.score,x:game.width/2,y:80,size:this.size,align:'center',color:"white",border:"black"});this.size=this.size-this.shrink;if(this.size<=100)this.size=100;}}
function drawTitleScreen(){frame.clearRect(0,0,game.width,game.height);gradient();title.draw();if(displayRestart)flashText.draw();if(score>0){drawText({text:"punches thrown: ",x:game.width/2,y:game.height/2-20,size:50,align:"center",color:"white",border:"black"});drawText({text:score,x:game.width/2,y:game.height/2+75,size:120,align:"center",color:"white",border:"black"});}
frameId=requestAnimationFrame(drawTitleScreen);}class Arm{constructor(src,x){this.arm=new Image();this.arm.onload=()=>{this.aspectRatio=this.arm.width/this.arm.height;}
this.arm.src=src;this.defaultX=x;this.defaultY=Math.floor(game.height*0.7);this.x=this.defaultX;this.y=this.defaultY;this.idle=true;this.angle=Math.floor(Math.random()*10);this.speed=0.05;this.shakeIntensity=4;}
draw(){if(this.idle){this.angle+=this.speed;let radius=30;let offsetX=Math.cos(this.angle)*radius;let offsetY=Math.sin(this.angle)*radius;offsetX+=Math.random()*this.shakeIntensity-this.shakeIntensity/2;offsetY+=Math.random()*this.shakeIntensity-this.shakeIntensity/2;this.x=this.defaultX+offsetX;this.y=this.defaultY+offsetY;}
frame.drawImage(this.arm,this.x,this.y,(game.width*0.3),((game.width*0.3)/this.aspectRatio));}
thrust(offset){this.idle=false;this.x=Math.floor((game.width/2)+offset);this.y=Math.floor((game.height/2)-(game.height*0.15));setTimeout(()=>{this.retract()},100);}
retract(){this.idle=true;this.angle=Math.floor(Math.random()*10);this.speed=0.05;this.shakeIntensity=4;this.x=this.defaultX;this.y=this.defaultY;}}
class Neko{constructor(){this.neko=new Image();this.neko.onload=()=>{this.aspectRatio=this.neko.width/this.neko.height;}
this.neko.src=`./img/neko_1.webp`;this.neko.frames=["",`./img/neko_1.webp`,`./img/neko_2.webp`,`./img/neko_3.webp`,`./img/neko_4.webp`,`./img/neko_5.webp`,`./img/neko_6.webp`,`./img/neko_7.webp`,`./img/neko_8.webp`,`./img/neko_9.webp`,`./img/neko_10.webp`]
this.defaultX=Math.floor(game.width*0.35);this.defaultY=Math.floor(game.height*0.25);this.x=this.defaultX;this.y=this.defaultY;this.punched=false;this.hook='right';this.animationSpeed=0.05;this.animationRange=25;this.animationOffset=0;}
draw(){if(!this.punched){if(score>0){this.neko.src=this.neko.frames[2];}
if(score>10){this.neko.src=this.neko.frames[3];}
if(score>20){this.neko.src=this.neko.frames[4];}
if(score>30){this.neko.src=this.neko.frames[5];}
if(score>40){this.neko.src=this.neko.frames[6];}
if(score>50){this.neko.src=this.neko.frames[7];}
if(score>60){this.neko.src=this.neko.frames[8];}
if(score>70){this.neko.src=this.neko.frames[9];}
if(score>80){this.neko.src=this.neko.frames[10];}
let offsetY=Math.sin(this.animationOffset)*this.animationRange;let bottomY=this.defaultY+(game.width*0.3)/this.aspectRatio;let newY=bottomY-(game.width*0.3)/this.aspectRatio-offsetY;frame.drawImage(this.neko,this.x,newY,(game.width*0.3),((game.width*0.3)/this.aspectRatio)+offsetY);this.animationOffset+=this.animationSpeed;}else{frame.drawImage(this.neko,this.x-(game.width*0.05),this.y+(game.width*0.02),(game.width*0.3)+(game.width*0.1),((game.width*0.3)/this.aspectRatio)-(game.width*0.02));}}
punch(rightHook){this.punched=true;this.rightHook=rightHook;setTimeout(()=>{this.punched=false;this.animationSpeed=0.05;this.animationRange=25;this.animationOffset=0;},100);}}
const upperSegment=Math.floor(game.width/8);const yValue=game.height-upperSegment;class Bomb{constructor(){this.bomb=new Image();this.bomb.onload=()=>{this.aspectRatio=this.bomb.width/this.bomb.height;}
this.bomb.src=`./img/b_4.webp`;this.bomb.frames=[``,`./img/b_1.webp`,`./img/b_2.webp`,`./img/b_3.webp`,`./img/b_4.webp`]
this.x=0;this.y=yValue;}
draw(){if(timeLeft<4){this.bomb.src=this.bomb.frames[timeLeft];}
frame.drawImage(this.bomb,this.x,this.y,(upperSegment),((upperSegment)/this.aspectRatio));}}
class String{constructor(second){this.string=new Image();this.string.onload=()=>{this.aspectRatio=this.string.width/this.string.height;}
this.second=3+second;this.string.src=(this.second<timeLeft)?`./img/s_0.webp`:`./img/s_1.webp`;this.x=second*upperSegment;this.y=yValue;}
draw(){if(this.second===timeLeft){this.string.src=`./img/s_1.webp`;}
if(this.second<=timeLeft){frame.drawImage(this.string,this.x,this.y,(upperSegment),((upperSegment)/this.aspectRatio))}}}
class bigBomb{constructor(){this.bomb=new Bomb();this.strings=[];for(let i=1;i<8;i++){this.strings.push(new String(i));}}
draw(){this.bomb.draw();for(let i=0;i<this.strings.length;i++){this.strings[i].draw();}}}
class Background{constructor(){this.bg=new Image();this.bg.onload=()=>{this.aspectRatio=this.bg.width/this.bg.height;}
this.bg.src=`./img/bg.webp`;}
draw(){frame.drawImage(this.bg,0,0,game.width,game.height);}}
function playSFX(src){let audio=new Audio(src);audio.play();audio=null;}
const bgm=new Audio(`./audio/Dungeon3.ogg`);const organ=new Audio(`./audio/Organ.ogg`);const background=new Background();let title=new titleText();let flashText=new flashingText();let scoreText=new currentScore();let bomb=new bigBomb();let neko=new Neko();const arms={};arms['left']=new Arm(`./img/left_arm.webp`,-(game.width*0.1));arms['right']=new Arm(`./img/right_arm.webp`,Math.floor(game.width-(game.width*0.2)));function endGame(){gameOver=true;displayRestart=false;frame.clearRect(0,0,game.width,game.height);game.removeEventListener('click',updateScoreValue);clearInterval(intervalId);cancelAnimationFrame(frameId);blood=[];bgm.pause();bgm.currentTime=0;organ.play();setTimeout(()=>{displayRestart=true},1000);titleScreen();}
function updateTimeLeftValue(){if(timeLeft>0)timeLeft--;}
function updateScoreValue(){if(gameOver)return;playSFX(`./audio/Blow3.ogg`);score++;(rightHook)?arms['right'].thrust(-(game.width*0.08)):arms['left'].thrust(-(game.width*0.23));(rightHook)?shootBlood(-1):shootBlood(1);neko.punch(rightHook);rightHook=!rightHook;}
function gameLoop(){frame.clearRect(0,0,game.width,game.height);background.draw();scoreText.draw();neko.draw();updateBlood();arms['right'].draw();arms['left'].draw();bomb.draw();if(timeLeft<=0){return endGame();}
if(!gameOver){frameId=requestAnimationFrame(gameLoop);}}
function startGame(){game.removeEventListener('click',startGame);cancelAnimationFrame(frameId);bgm.play();timeLeft=defaultTimeLeft;score=defaultScore;gameOver=false;bomb=new bigBomb();neko=new Neko();scoreText=new currentScore();gameLoop();game.addEventListener('click',updateScoreValue);intervalId=setInterval(updateTimeLeftValue,1000);}
function titleScreen(){if(score>0){title=new titleText("YOU KICKED HIS ASS!",120,130,-100,0.3);flashText=new flashingText('click to restart!',150);}else{title=new titleText("NEKO PUNCHER",150,180);flashText=new flashingText('click to start!',50);}
if(gameOver){setTimeout(()=>{game.addEventListener('click',startGame)},1000);}else{game.addEventListener('click',startGame);}
drawTitleScreen();}
function main(){document.addEventListener('keydown',function(event){if(event.key==='p'||event.key==='P'){recordSnippet();}});titleScreen();}